
#ifndef IEEE1905_DEPS
#define IEEE1905_DEPS

extern int (*t_map_prepare_cmdu_mask)(uint8_t mask[], ...);

extern int (*t_map_subscribe)(void *bus, void *publisher,
                  const char *name, mapmodule_cmdu_mask_t *mask, void *priv,
                  int (*sub_cb)(void *bus, void *priv, void *data),
                  int (*del_cb)(void *bus, void *priv, void *data),
                  void **subscriber);

extern int (*t_cmdu_ackq_init)(void *q);
extern void (*t_cmdu_ackq_free)(void *q);
extern int (*t_cmdu_ackq_dequeue)(void *q, uint16_t type, uint16_t mid, uint8_t *src,
			     void **cookie);
extern int (*t_cmdu_ackq_enqueue)(void *q, uint16_t type, uint16_t mid, uint8_t *dest,
			     uint32_t timeout, int resend_cnt, void *cookie);



extern struct cmdu_buff *(*t_cmdu_alloc_simple)(uint16_t type, uint16_t *mid);

extern struct cmdu_buff *(*t_cmdu_alloc_custom)(uint16_t type, uint16_t *mid,
				    char *ifname, uint8_t *origin,
				    uint8_t *tlvs, uint32_t tlvslen);

extern void (*t_cmdu_free)(struct cmdu_buff *c);


extern uint16_t (*t_cmdu_get_mid)(struct cmdu_buff *c);
extern uint8_t (*t_cmdu_get_fid)(struct cmdu_buff *c);
extern uint16_t (*t_cmdu_get_type)(struct cmdu_buff *c);


extern int (*t_cmdu_parse_tlvs)(struct cmdu_buff *c, struct tlv *tv[][16],
		    struct tlv_policy *policy, int policy_len);


extern int (*t_cmdu_put_eom)(struct cmdu_buff *c);
extern int (*t_cmdu_put_tlv)(struct cmdu_buff *c, struct tlv *t);
extern struct tlv *(*t_cmdu_reserve_tlv)(struct cmdu_buff *c, uint16_t tlv_datalen);
extern uint16_t (*t_tlv_length)(struct tlv *t);

int topologyd_use_ieee1905(void);

#endif /* IEEE1905_DEPS */
